﻿#ifndef LINEEDITWIDGET_H
#define LINEEDITWIDGET_H

#include <QLineEdit>
#include "IxWidget.h"

class LineEditWidget : public QLineEdit, public IxWidget
{
	Q_OBJECT
public:
	static const QString type;

public:
    LineEditWidget(QWidget *parent);

	IXWIDGET_OBJECT_NAME

	void setIntValidator(int min, int max);

	void setDoubleValidator(double min, double max, int Precision);

	void setRegExpValidator(const QString& regExp);
public:
	QVariant getValue() const override;

	void setValue(const QVariant &value) override;

	bool isValueNull() const override;

	void clearInput() override;
};

#endif // LINEEDITWIDGET_H
